stages:
  - build
  - test
  #- dockerize
  - deploy

build:
  stage: build
  image: mcr.microsoft.com/dotnet/sdk:8.0 # Replace with compatible .NET image
  script:
    - cd cicdprj  # Navigate to the project directory
    - dotnet restore  # Restore NuGet packages
    - dotnet build --configuration Release  # Build in Release configuration

test:
  stage: test
  image: mcr.microsoft.com/dotnet/sdk:8.0  # Same or compatible image as build
  script:
    - cd jcotest  # Navigate to the test project directory
    - dotnet test --no-build  # Run tests without rebuilding (assuming build stage succeeds)


# build_image:
#   stage: dockerize
#   image: docker:20.10.16
#   services:
#     - docker:20.10.16-dind
#   variables:
#     DOCKER_TLS_CERTDIR: "/certs"
#   before_script:
#     - docker login -u hamidmt -p qaz12345@
#   script:
#     - docker build -t mysite:0.1 .
#     - docker push mysite:0.

deploy:
  stage: deploy
  image: mcr.microsoft.com/dotnet/sdk:8.0  # Use an image that includes or allows installing additional software
  before_script:
    - apt-get update && apt-get install -y lftp  # Install lftp, adjust if using a non-Debian-based image
  script:
    - cd cicdprj  # Navigate to the project directory
    - dotnet publish --configuration Release --output ./publish  # Publish the project
    - lftp -u test15,qaz12345 -e "set ssl:verify-certificate no; mirror --reverse --verbose ./publish/ /; quit" ftp://ftp.tamirniaz.ir
    - echo "Deployment completed successfully."